VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5730
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6225
   LinkTopic       =   "Form1"
   ScaleHeight     =   5730
   ScaleWidth      =   6225
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim vTop(3) As D3DVERTEX
Dim vBottom(3) As D3DVERTEX
Dim vLeft(3) As D3DVERTEX
Dim vBack(3) As D3DVERTEX
Dim vRight(3) As D3DVERTEX
Dim vFront(3) As D3DVERTEX

Dim Texture As DirectDrawSurface7
Dim Ddsd2 As DDSURFACEDESC2

Dim I As Long
Private Sub Form_Click()
On Error Resume Next
Set D3d = Nothing
Set Dx = Nothing
Set Device = Nothing
Set Dd = Nothing
Set Texture = Nothing
End
End Sub



Private Sub Form_Load()
Init_Direct3DIM 600, 800, 16
Init_Vertex
CreateTexture
Dx.IdentityMatrix MatWorld
Device.SetTransform D3DTRANSFORMSTATE_WORLD, MatWorld

Dx.ProjectionMatrix MatProj, 1, 100, PI / 2
Device.SetTransform D3DTRANSFORMSTATE_PROJECTION, MatProj

Dx.ViewMatrix MatView, MakeVector(0, 10, -10), MakeVector(0, 0, 0), MakeVector(0, 1, 0), 0
Device.SetTransform D3DTRANSFORMSTATE_VIEW, MatView

Dim Mat7 As D3DMATERIAL7
With Mat7
.Ambient.b = 1: .Ambient.g = 1: .Ambient.R = 1
.diffuse.b = 1: .diffuse.g = 1: .diffuse.R = 1
End With
Device.SetMaterial Mat7

Device.SetRenderState D3DRENDERSTATE_AMBIENT, Dx.CreateColorRGBA(1, 1, 1, 0)

Dim Light7 As D3DLIGHT7

With Light7
 .dltType = D3DLIGHT_POINT
 .position = MakeVector(10, 0, -10)
 .attenuation1 = 0.05
 
 .diffuse.a = 1
 .diffuse.R = 1
 .diffuse.b = 0
 .diffuse.g = 0
 .range = 100
End With

Device.SetLight 0, Light7

Device.LightEnable 0, True

Device.SetRenderState D3DRENDERSTATE_LIGHTING, True

Device.SetRenderState D3DRENDERSTATE_SHADEMODE, D3DSHADE_GOURAUD


Dim ClearRect(0 To 0) As D3DRECT
ClearRect(0).X2 = 800
ClearRect(0).Y2 = 600
Dim R As Integer
Do

R = R - 1
If R <= 0 Then R = 360

Dx.RotateYMatrix MatWorld, R * (Rad)

Device.SetTransform D3DTRANSFORMSTATE_WORLD, MatWorld
DoEvents
Device.Clear 1, ClearRect, D3DCLEAR_TARGET, 0, 0, 0
Device.BeginScene

Device.SetTexture 0, Texture
Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, vFront(0), 4, D3DDP_WAIT

Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, vTop(0), 4, D3DDP_WAIT

Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, vLeft(0), 4, D3DDP_WAIT

Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, vBack(0), 4, D3DDP_WAIT

Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, vRight(0), 4, D3DDP_WAIT

Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, vBottom(0), 4, D3DDP_WAIT

Device.EndScene

Primary.Flip Nothing, DDFLIP_WAIT

Loop

End Sub
Sub Init_Vertex()
' Create the front face
Dx.CreateD3DVertex 2, -2, 0, 0, 0, -1, 0, 0, vFront(0)
Dx.CreateD3DVertex -2, -2, 0, 0, 0, -1, 1, 0, vFront(1)
Dx.CreateD3DVertex 2, 2, 0, 0, 0, -1, 0, 1, vFront(2)
Dx.CreateD3DVertex -2, 2, 0, 0, 0, 1, 1, 1, vFront(3)

'Create the top face
Dx.CreateD3DVertex -2, 2, 5, 0, 0, -1, 0, 0, vTop(0)
Dx.CreateD3DVertex 2, 2, 5, 0, 0, -1, 1, 0, vTop(1)
Dx.CreateD3DVertex -2, 2, 0, 0, 0, -1, 0, 1, vTop(2)
Dx.CreateD3DVertex 2, 2, 0, 0, 0, 1, 1, 1, vTop(3)

'Create the left face
Dx.CreateD3DVertex 2, 2, 0, 0, 0, -1, 0, 0, vLeft(0)
Dx.CreateD3DVertex 2, 2, 5, 0, 0, -1, 1, 0, vLeft(1)
Dx.CreateD3DVertex 2, -2, 0, 0, 0, -1, 0, 1, vLeft(2)
Dx.CreateD3DVertex 2, -2, 5, 0, 0, 1, 1, 1, vLeft(3)

'create the back face
Dx.CreateD3DVertex 2, 2, 5, 0, 0, -1, 0, 0, vBack(0)
Dx.CreateD3DVertex -2, 2, 5, 0, 0, -1, 1, 0, vBack(1)
Dx.CreateD3DVertex 2, -2, 5, 0, 0, -1, 0, 1, vBack(2)
Dx.CreateD3DVertex -2, -2, 5, 0, 0, 1, 1, 1, vBack(3)

'create the right face
Dx.CreateD3DVertex -2, 2, 5, 0, 0, -1, 0, 0, vRight(0)
Dx.CreateD3DVertex -2, 2, 0, 0, 0, -1, 1, 0, vRight(1)
Dx.CreateD3DVertex -2, -2, 5, 0, 0, -1, 0, 1, vRight(2)
Dx.CreateD3DVertex -2, -2, 0, 0, 0, 1, 1, 1, vRight(3)

'create the bottom face
Dx.CreateD3DVertex -2, -2, 0, 0, 0, -1, 0, 0, vBottom(0)
Dx.CreateD3DVertex 2, -2, 0, 0, 0, -1, 1, 0, vBottom(1)
Dx.CreateD3DVertex -2, -2, 5, 0, 0, -1, 0, 1, vBottom(2)
Dx.CreateD3DVertex 2, -2, 5, 0, 0, 1, 1, 1, vBottom(3)
End Sub

Sub CreateTexture()
Dim tEnum As Direct3DEnumPixelFormats

Ddsd2.lFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH Or DDSD_PIXELFORMAT Or DDSD_TEXTURESTAGE

Set tEnum = Device.GetTextureFormatsEnum

For I = 1 To tEnum.GetCount
tEnum.GetItem I, Ddsd2.ddpfPixelFormat

If Ddsd2.ddpfPixelFormat.lRGBBitCount = 16 Then Exit For

Next

If Ddsd2.ddpfPixelFormat.lRGBBitCount <> 16 Then End

Ddsd2.ddsCaps.lCaps = DDSCAPS_TEXTURE
Ddsd2.ddsCaps.lCaps2 = DDSCAPS2_TEXTUREMANAGE
Ddsd2.lTextureStage = 0

Set Texture = Dd.CreateSurfaceFromFile(App.Path & "\Texture.bmp", Ddsd2)
End Sub
