VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5730
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6225
   LinkTopic       =   "Form1"
   ScaleHeight     =   5730
   ScaleWidth      =   6225
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim RECT1(3) As D3DVERTEX
Dim Land(3) As D3DVERTEX
Dim Texture As DirectDrawSurface7
Dim Texture2 As DirectDrawSurface7
Dim Ddsd2 As DDSURFACEDESC2
Dim Mat1 As D3DMATRIX

Dim Angel As Integer
Dim Rotation As D3DVECTOR
Dim Position As D3DVECTOR
Dim I As Long
Private Sub Form_Click()
On Error Resume Next
Set D3d = Nothing
Set Dx = Nothing
Set Device = Nothing
Set Dd = Nothing
Set Texture = Nothing
End
End Sub

Private Sub Form_Load()
Init_Direct3DIM 600, 800, 16
Init_Vertex
CreateTexture
Dx.IdentityMatrix MatWorld
Device.SetTransform D3DTRANSFORMSTATE_WORLD, MatWorld

Dx.ProjectionMatrix MatProj, 1, 100, PI / 2
Device.SetTransform D3DTRANSFORMSTATE_PROJECTION, MatProj

Dx.ViewMatrix MatView, MakeVector(0, 10, 0), MakeVector(0, 0, 10), MakeVector(0, 1, 0), 0
Device.SetTransform D3DTRANSFORMSTATE_VIEW, MatView

Dim Mat7 As D3DMATERIAL7
With Mat7
.Ambient.b = 1: .Ambient.g = 1: .Ambient.R = 1
.diffuse.b = 1: .diffuse.g = 1: .diffuse.R = 1
End With
Device.SetMaterial Mat7

Device.SetRenderState D3DRENDERSTATE_AMBIENT, Dx.CreateColorRGBA(1, 1, 1, 0)

Dim Light7 As D3DLIGHT7

With Light7
 .dltType = D3DLIGHT_POINT
 .Position = MakeVector(0, 50, 0)
 .direction = MakeVector(0, 1, 0)
 .attenuation1 = 1
 
 .diffuse.a = 1
 .diffuse.R = 1
 .diffuse.b = 0
 .diffuse.g = 0
 .range = 100
End With

Device.SetLight 0, Light7

Device.LightEnable 0, True

Device.SetRenderState D3DRENDERSTATE_LIGHTING, 1

Device.SetRenderState D3DRENDERSTATE_SHADEMODE, D3DSHADE_GOURAUD


Dim ClearRect(0 To 0) As D3DRECT
ClearRect(0).X2 = 400
ClearRect(0).Y2 = 600
Dim R As Integer

Dim Clearrect2(0 To 0) As D3DRECT
Clearrect2(0).X2 = 800
Clearrect2(0).X1 = 400
Clearrect2(0).Y1 = 0
Clearrect2(0).Y2 = 600
Dim TempMat As D3DMATRIX


Rotation.X = Cos(Angel * Rad)
Rotation.Z = Sin(Angel * Rad)

Dim ViewPort As D3DVIEWPORT7
With ViewPort
 .lHeight = 600
 .lWidth = 400
 .lX = 0
 .lY = 0
 .maxz = 1
 .minz = 0
End With

Dim ViewPort2 As D3DVIEWPORT7

With ViewPort2
 .lHeight = 600
 .lWidth = 400
 .lX = 400
 .lY = 0
 .maxz = 1
 .minz = 0
End With

Dim Camera2 As D3DMATRIX

Do

Dx.RotateYMatrix Mat1, Angel * Rad
TranslateMatrix TempMat, Position.X, Position.Y, Position.Z
Device.SetTransform D3DTRANSFORMSTATE_VIEW, MatView
Dx.MatrixMultiply Mat1, Mat1, TempMat

DoEvents
Device.SetViewport ViewPort
Device.SetTransform D3DTRANSFORMSTATE_VIEW, MatView

Device.Clear 1, ClearRect, D3DCLEAR_TARGET, 0, 0, 0

Device.BeginScene
Device.SetTexture 0, Texture2
Device.SetTransform D3DTRANSFORMSTATE_WORLD, MatWorld
Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, Land(0), 4, D3DDP_WAIT
Device.SetTexture 0, Texture
Device.SetTransform D3DTRANSFORMSTATE_WORLD, Mat1
Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, RECT1(0), 4, D3DDP_WAIT
Device.EndScene


Dx.ViewMatrix Camera2, MakeVector(Position.X - 5, 10, Position.Z + 4), Position, MakeVector(0, 1, 0), 0
Device.SetTransform D3DTRANSFORMSTATE_VIEW, Camera2
Device.SetViewport ViewPort2
Device.Clear 1, Clearrect2, D3DCLEAR_TARGET, 0, 0, 0
Device.BeginScene
Device.SetTexture 0, Texture2
Device.SetTransform D3DTRANSFORMSTATE_WORLD, MatWorld
Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, Land(0), 4, D3DDP_WAIT
Device.SetTexture 0, Texture
Device.SetTransform D3DTRANSFORMSTATE_WORLD, Mat1
Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, RECT1(0), 4, D3DDP_WAIT
Device.EndScene
Back_Buffer.SetForeColor Dx.CreateColorRGB(0.5, 0.5, 0.5)
Back_Buffer.DrawText 20, 20, CStr(Position.X), False
Back_Buffer.DrawText 20, 60, CStr(Position.Z), False
Primary.Flip Nothing, DDFLIP_WAIT
GetKeys
Loop

End Sub
Sub Init_Vertex()
Dx.CreateD3DVertex -2, 0, -2, 0, 0, -1, 0, 0, RECT1(0)
Dx.CreateD3DVertex -2, 0, 2, 0, 0, -1, 1, 0, RECT1(1)
Dx.CreateD3DVertex 2, 0, -2, 0, 0, -1, 0, 1, RECT1(2)
Dx.CreateD3DVertex 2, 0, 2, 0, 0, 1, 1, 1, RECT1(3)

Dx.CreateD3DVertex -20, 0, 20, 0, 0, -1, 0, 0, Land(0)
Dx.CreateD3DVertex 20, 0, 20, 0, 0, -1, 1, 0, Land(1)
Dx.CreateD3DVertex -20, 0, -20, 0, 0, -1, 0, 1, Land(2)
Dx.CreateD3DVertex 20, 0.1, -20, 0, 0, 1, 1, 1, Land(3)

End Sub

Sub CreateTexture()
Dim tEnum As Direct3DEnumPixelFormats

Ddsd2.lFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH Or DDSD_PIXELFORMAT Or DDSD_TEXTURESTAGE

Set tEnum = Device.GetTextureFormatsEnum

For I = 1 To tEnum.GetCount
tEnum.GetItem I, Ddsd2.ddpfPixelFormat

If Ddsd2.ddpfPixelFormat.lRGBBitCount = 16 Then Exit For

Next

If Ddsd2.ddpfPixelFormat.lRGBBitCount <> 16 Then End

Ddsd2.ddsCaps.lCaps = DDSCAPS_TEXTURE
Ddsd2.ddsCaps.lCaps2 = DDSCAPS2_TEXTUREMANAGE
Ddsd2.lTextureStage = 0

Set Texture = Dd.CreateSurfaceFromFile(App.Path & "\Texture.bmp", Ddsd2)
Set Texture2 = Dd.CreateSurfaceFromFile(App.Path & "\texture1.bmp", Ddsd2)
End Sub

Sub GetKeys()
Didev.GetDeviceStateKeyboard DiKey
If DiKey.Key(DIK_DOWN) Then
Position.X = Position.X + (Rotation.X * 0.2)
Position.Z = Position.Z + (Rotation.Z * 0.2)
End If

If DiKey.Key(DIK_UP) Then
Position.X = Position.X - (Rotation.X * 0.2)
Position.Z = Position.Z - (Rotation.Z * 0.2)
End If

If Position.X < -18 Then Position.X = -18
If Position.Z < -19 Then Position.Z = -19
If Position.X > 18 Then Position.X = 18
If Position.Z > 19 Then Position.Z = 19

If DiKey.Key(DIK_LEFT) Then
Angel = Angel + 1
If Angel > 360 Then Angel = 1
Rotation.X = Cos(Angel * Rad)
Rotation.Z = Sin(Angel * Rad)
End If

If DiKey.Key(DIK_RIGHT) Then
Angel = Angel - 1
If Angel < 0 Then Angel = 359
Rotation.X = Cos(Angel * Rad)
Rotation.Z = Sin(Angel * Rad)
End If
End Sub
Sub TranslateMatrix(Matrix As D3DMATRIX, X As Single, Y As Single, Z As Single)
Dx.IdentityMatrix Matrix
With Matrix
.rc41 = X
.rc42 = Y
.rc43 = Z
End With
If X <> 0 Or Y <> 0 Or Z <> 0 Then Dx.ViewMatrix MatView, MakeVector(Position.X + Rotation.X * 5, 3, Position.Z + Rotation.Z * 5), Position, MakeVector(0, 1, 0), 0
End Sub
