VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5730
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6225
   LinkTopic       =   "Form1"
   ScaleHeight     =   5730
   ScaleWidth      =   6225
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim vTop(3) As D3DLVERTEX
Dim vBottom(3) As D3DLVERTEX
Dim vLeft(3) As D3DLVERTEX
Dim vBack(3) As D3DLVERTEX
Dim vRight(3) As D3DLVERTEX
Dim vFront(3) As D3DLVERTEX
Dim cWhite As Long
Dim cRed As Long
Dim cGreen As Long
Dim cBlue As Long

Private Sub Form_Click()
End
End Sub

Private Sub Form_Load()
Init_Direct3DIM 600, 800, 16
cWhite = Dx.CreateColorRGB(1, 1, 1)
cRed = Dx.CreateColorRGB(1, 0, 0)
cGreen = Dx.CreateColorRGB(0, 1, 0)
cBlue = Dx.CreateColorRGB(0, 0, 1)
Init_Vertex

Dx.IdentityMatrix MatWorld
Device.SetTransform D3DTRANSFORMSTATE_WORLD, MatWorld

Dx.ProjectionMatrix MatProj, 1, 100, PI / 2
Device.SetTransform D3DTRANSFORMSTATE_PROJECTION, MatProj

Dx.ViewMatrix MatView, MakeVector(0, 10, -10), MakeVector(0, 0, 0), MakeVector(0, 1, 0), 0
Device.SetTransform D3DTRANSFORMSTATE_VIEW, MatView

Device.SetRenderState D3DRENDERSTATE_LIGHTING, 0
Device.SetRenderState D3DRENDERSTATE_SHADEMODE, D3DSHADE_GOURAUD
Dim ClearRect(0 To 0) As D3DRECT
ClearRect(0).X2 = 800
ClearRect(0).Y2 = 600
Dim R As Integer
Do
R = R - 1
If R <= 0 Then R = 360

Dx.RotateYMatrix MatWorld, R * (Rad)


Device.SetTransform D3DTRANSFORMSTATE_WORLD, MatWorld
DoEvents
Device.Clear 1, ClearRect, D3DCLEAR_TARGET, 0, 0, 0
Device.BeginScene

Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, vFront(0), 4, D3DDP_WAIT
Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, vTop(0), 4, D3DDP_WAIT
Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, vLeft(0), 4, D3DDP_WAIT
Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, vBack(0), 4, D3DDP_WAIT
Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, vRight(0), 4, D3DDP_WAIT
Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, vBottom(0), 4, D3DDP_WAIT

Device.EndScene

Primary.Flip Nothing, DDFLIP_WAIT

Loop

End Sub
Sub Init_Vertex()
' Create the front face
Dx.CreateD3DLVertex 2, -2, 0, cWhite, 1, 0, 0, vFront(0)
Dx.CreateD3DLVertex -2, -2, 0, cRed, 1, 0, 0, vFront(1)
Dx.CreateD3DLVertex 2, 2, 0, cGreen, 1, 0, 0, vFront(2)
Dx.CreateD3DLVertex -2, 2, 0, cBlue, 1, 0, 0, vFront(3)

'Create the top face
Dx.CreateD3DLVertex -2, 2, 5, cRed, 1, 0, 0, vTop(0)
Dx.CreateD3DLVertex 2, 2, 5, cWhite, 1, 0, 0, vTop(1)
Dx.CreateD3DLVertex -2, 2, 0, cBlue, 1, 0, 0, vTop(2)
Dx.CreateD3DLVertex 2, 2, 0, cGreen, 1, 0, 0, vTop(3)

'Create the left face
Dx.CreateD3DLVertex 2, 2, 0, cBlue, 1, 0, 0, vLeft(0)
Dx.CreateD3DLVertex 2, 2, 5, cWhite, 1, 0, 0, vLeft(1)
Dx.CreateD3DLVertex 2, -2, 0, cGreen, 1, 0, 0, vLeft(2)
Dx.CreateD3DLVertex 2, -2, 5, cRed, 1, 0, 0, vLeft(3)

'create the back face
Dx.CreateD3DLVertex 2, 2, 5, cWhite, 1, 0, 0, vBack(0)
Dx.CreateD3DLVertex -2, 2, 5, cRed, 1, 0, 0, vBack(1)
Dx.CreateD3DLVertex 2, -2, 5, cBlue, 1, 0, 0, vBack(2)
Dx.CreateD3DLVertex -2, -2, 5, cGreen, 1, 0, 0, vBack(3)

'create the right face
Dx.CreateD3DLVertex -2, 2, 5, cBlue, 1, 0, 0, vRight(0)
Dx.CreateD3DLVertex -2, 2, 0, cGreen, 1, 0, 0, vRight(1)
Dx.CreateD3DLVertex -2, -2, 5, cWhite, 1, 0, 0, vRight(2)
Dx.CreateD3DLVertex -2, -2, 0, cRed, 1, 0, 0, vRight(3)

'create the bottom face
Dx.CreateD3DLVertex -2, -2, 0, cRed, 1, 0, 0, vBottom(0)
Dx.CreateD3DLVertex 2, -2, 0, cGreen, 1, 0, 0, vBottom(1)
Dx.CreateD3DLVertex -2, -2, 5, cBlue, 1, 0, 0, vBottom(2)
Dx.CreateD3DLVertex 2, -2, 5, cWhite, 1, 0, 0, vBottom(3)
End Sub
